<template>
  <div class="app-container">
    <el-row :gutter="10" class="filter-container">
      <el-col :span="18">
        <el-input
          v-model="query.name.$search"
          @input="filter"
          placeholder="Busqueda por nombre"
          prefix-icon="el-icon-search"
        >
          <el-button slot="append" v-if="clearFilterEnabled" icon="el-icon-close" @click="clearFilter()" />
        </el-input>
      </el-col>
      <el-col :span="6">
        <el-button class="filter-item" @click="goCreate()" type="success" icon="el-icon-circle-plus">Nuevo Vendedor</el-button>
      </el-col>
    </el-row>

    <el-table key="_id" :data="rows" v-loading="listLoading" border fit highlight-current-row
      style="width: 100%" stripe>
      <el-table-column align="center" label="ID" width="65">
        <template slot-scope="scope">
          <span>{{scope.row.code}}</span>
        </template>
      </el-table-column>

      <el-table-column min-width="100px" label="Nombre">
        <template slot-scope="scope">
          <span class="link-type" @click="goUpdate(scope.row)">{{scope.row.name}}</span>
        </template>
      </el-table-column>

      <el-table-column min-width="100px" label="E-Mail">
        <template slot-scope="scope">
          <span class="link-type" @click="handleUpdate(scope.row)">{{scope.row.email}}</span>
        </template>
      </el-table-column>

      <el-table-column label="Operaciones" width="160px" fixed="right" class-name="small-padding fixed-width" center>
        <template slot-scope="scope">
          <el-button type="primary" size="mini" @click="goUpdate(scope.row)">
            Editar
          </el-button>
          <el-button type="danger" size="mini" @click="remove(scope.row)">
            Borrar
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    </transition-group>
  </div>
</template>

<script>
  import { DateTime } from 'luxon'
  import { debounce } from 'lodash'
  import api from '@/feathers'

  export default {
    name: 'salesmen-list',
    data() {
      return {
        rows: [],
        query: {
          name: {$search: ''}
        },
        listLoading: true,
      }
    },
    created() {
      this.getList()
      this.filter = debounce(this.filter, 500)
    },
    computed: {
      clearFilterEnabled() {
        return this.query.name.$search !== ''
      }
    },
    methods: {
      clearFilter() {
        this.query.name.$search=''
        this.handleFilter()
      },
      async getList() {
        this.listLoading = true
        this.rows = await api.service('salesmen').find()
        this.listLoading = false
      },
      goCreate() {
        this.$router.push({name: 'salesmen-new'})
      },
      goUpdate(row) {
        this.$router.push({
          name: 'salesmen-update',
          params: {id: row._id}
        })
      },
      async filter() {
        this.listLoading = true
        const salesmenService = api.service('salesmen')
        this.rows = await salesmenService.find({
          query: this.query
        })
        this.listLoading = false
      },
      remove(row) {
        return this
          .$confirm('¿Está seguro que desea eliminar el registro?')
          .then(() =>  api.service('salesmen').remove(row._id))
        // TODO: Hacer que el refresh lo maneje con el evento de socketio
          .then(() => this.getList())
      }
    }
  }
</script>
